/* $Id: class.h,v 1.6 2000/11/15 15:41:11 malekith Exp $ */

#include "util.h"
#include "y.tab.h"
#include "token.h"
#include "phash.h"

enum {
	ctx_none,
	ctx_sys,
	ctx_this,
	ctx_arg,
	ctx_local,
	ctx_ptr,
};

/* TYPES: */
struct var_type {
	int id;
	struct class_def *ptr;
};

int size_of(struct var_type *t);
char *name_of(struct var_type *t);
int token2type(struct var_type *v, struct token *t);
int types_diffrent(struct var_type *p1, struct var_type *p2);
void copy_type(struct var_type *dst, const struct var_type *src);
void oops(struct token *, const char *, ...);
char *take_string(struct token *t);

/* VARS: */
struct var {
	/* phash_entry: */
	struct var *next;
	const char *name;

	int offset;
	struct var_type type;
	int ctx;
};

struct class_def;

struct class_func {
	/* phash_entry: */
	struct class_var *next;
	const char *name;

	struct var_type type;
	struct var *args;
	int id;
	int syscall;

	int ctx;			/* ctx_this / ctx_sys */
	struct class_def *ctx_class;	/* to force specific class */
};

struct class_def {
	/* phash_entry: */
	struct class_def *next;
	const char *name;

	struct class_def *super;	/* supertype */
	int datasize;
	int funcsize;
	int id;				/* local id */

	struct dbuf *funcs_xrefs;

	int def_dtor;
	
	struct phash *vars, *funcs;

	struct class_def *lnext;	/* classes are also linked in
					 * list to allow easy dump
					 * of their names and ids */
};

extern struct phash *class_hash;
extern struct class_def *system_class;

int proto_args_diffrent(struct var *p1, struct var *p2);
struct var *make_arg_list(struct token *t, int *sp);

#define SYN(t, xxx) \
	assert(t->sel == sel_syn && t->v_int == syn_ ## xxx)
	
/* function */
struct func_def {
	struct func_def *next;
	char *name;
	
	struct class_def *parent;
	struct var_type type;
	int id;
	struct var *args;
	unsigned int block;
};

extern struct func_def *func_head;
